varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform lowp sampler2D samplerBack;
uniform mediump vec2 destStart;
uniform mediump vec2 destEnd;
uniform mediump vec2 srcStart;
uniform mediump vec2 srcEnd;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump vec2 layoutSize;
uniform mediump vec2 pixelSize;
uniform mediump float seconds;

uniform mediump float intensity;
uniform mediump float maxOffset;
uniform mediump float speed;
precision mediump float;

const float pi = 3.14156;

vec4 getBack(vec2 off) 
{
    vec2 n = (vTex + off - srcStart) / (srcEnd - srcStart);
    return texture2D(samplerBack, mix(destStart, destEnd, n));
}

void main(void)
{
    //vec2 texelSize = abs(srcOriginEnd-srcOriginStart)/layoutSize;
    float progress = seconds * speed;
    vec2 offsetR = vec2(maxOffset * pixelSize.x * cos(progress * 2. * pi),        maxOffset * pixelSize.x * cos(progress*0.7 * 2. * pi));
	vec2 offsetG = vec2(maxOffset * pixelSize.x * cos(1. + (progress * 2. * pi)), maxOffset * pixelSize.x * cos(3. + (progress*0.7 * 2. * pi)));
	vec2 offsetB = vec2(maxOffset * pixelSize.x * cos(progress * 1.5 * pi),       maxOffset * pixelSize.x * cos(progress*0.9 * 2. * pi));
	
	vec4 backColR = getBack(offsetR);
	vec4 backColG = getBack(offsetG);
	vec4 backColB = getBack(offsetB);
	
	vec4 texCol = texture2D(samplerFront, vTex);

    gl_FragColor = mix(texCol, texCol.a * vec4(backColR.r, backColG.g, backColB.b, 1.0), intensity);
}
