﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

%%SAMPLERBACK_BINDING%% var samplerBack : sampler;
%%TEXTUREBACK_BINDING%% var textureBack : texture_2d<f32>;

struct ShaderParams {
	intensity : f32,
	maxOffset : f32,
	speed : f32,
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%


const pi: f32 = 3.14156;

fn getBack(off: vec2<f32>, fuv: vec2<f32>) -> vec4<f32> {
	return textureSample(textureBack, samplerBack, c3_getBackUV(fuv, textureBack) + off);
}

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{	let pixelSize: vec2<f32> = c3_getPixelSize(textureBack);
	let progress: f32 = c3Params.seconds * shaderParams.speed;
	let offsetR: vec2<f32> = vec2<f32>(shaderParams.maxOffset * pixelSize.x * cos(progress * 2. * pi), shaderParams.maxOffset * pixelSize.x * cos(progress * 0.7 * 2. * pi));
	let offsetG: vec2<f32> = vec2<f32>(shaderParams.maxOffset * pixelSize.x * cos(1. + progress * 2. * pi), shaderParams.maxOffset * pixelSize.x * cos(3. + progress * 0.7 * 2. * pi));
	let offsetB: vec2<f32> = vec2<f32>(shaderParams.maxOffset * pixelSize.x * cos(progress * 1.5 * pi), shaderParams.maxOffset * pixelSize.x * cos(progress * 0.9 * 2. * pi));
	let backColR: vec4<f32> = getBack(offsetR, input.fragPos.xy);
	let backColG: vec4<f32> = getBack(offsetG, input.fragPos.xy);
	let backColB: vec4<f32> = getBack(offsetB, input.fragPos.xy);
	let texCol: vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);

	var output : FragmentOutput;
	output.color = mix(texCol, texCol.a * vec4<f32>(backColR.r, backColG.g, backColB.b, 1.), shaderParams.intensity);
	return output;
}